//Node application that gets real time tweets

console.log('The bot is starting');

var Twit = require('twit'); //Import the twitt package
var config = require('./config'); //require config --> the api keys
var cenode = require('./cenode.js');
var CL = require('coastline');
var my_name = 'User';


var natural = require('natural');
var mysql = require('mysql');

var myModel = [
  "conceptualise a ~ festival thing ~ F that is an entity and is an imageable thing.",
  "conceptualise a ~ band ~ B that is a festival thing.",
  "conceptualise a ~ time ~ T.",
  "conceptualise a ~ song ~ S that is a festival thing that has the value W as ~ title ~.",
  "conceptualise an ~ stage ~ L that is a festival thing and is a locatable thing.",
  "conceptualise the song S ~ is played by ~ the musician M.",
  "conceptualise the band B ~ plays at ~ the time T and ~ plays ~ the song S and  and has the stage L as ~ venue ~.",

  "there is a stage named 'pyramid stage' that is in the location 'Main Stages'.",
  "there is a stage named 'other stage' that is in the location 'Main Stages'.",
  "there is a stage named 'west holts' that is in the location 'Main Stages'.",
  "there is a stage named 'the park stage' that is in the location 'Main Stages'.",
  "there is a stage named 'JOHN PEEL STAGE' that is in the location 'Main Stages'.",

];

var node = new cenode.CENode(cenode.MODELS.CORE,myModel);
node.agent.set_name("agent1");


var perfomers = ["Florence and the Machine",
"The Libertines",
"Motorhead",
"Mary J Blige",
"Jamie xx",
"Alabama Shakes",
"James Bay",
"Chronixx",
"Michael Clark Company",
"Rudimental",
"Mark Ronson",
"The Courteeners",
"The Vaccines",
"Jungle",
"Catfish and the Bottlemen",
"Everything Everything",
"The Cribs",
"The Charlatans",
"Enter Shikari",
"Modestep",
"SBTRKT",
"Circa Waves",
"Peace",
"Chet Faker",
"The Districts",
"Leon Bridges",
"Rainy Boy Sleep",
"Hinds",
"Weaves",
"Kanye West",
"Pharrell Williams",
"Paloma Faith",
"Burt Bacharach",
"George Ezra",
"The Waterboys",
"Courtney Barnett",
"The Unthanks",
"Deadmau5",
"Ben Howard",
"The Maccabees",
"Clean Bandit",
"Ella Eyre",
"Young Fathers",
"The Strypes",
"Frank Turner",
"Swim Deep",
"Hot Chip",
"Suede",
"La Roux",
"Death from Above 1979",
"Jessie Ware",
"Years & Years",
"The Pop Group",
"Sleaford Mods",
"Slaves",
"Coasts",
"Sunset Sons",
"Isaac Lee-Kronick"
];

//var saturday = ["Clean Bandit"];

var stages = ["PYRAMID STAGE",
"OTHER STAGE",
"WEST HOLTS",
"THE PARK STAGE",
"JOHN PEEL STAGE"];

function getNameExact(tweet,option){

	for(var i = 0; i<option.length;i++){
		var inputString = option[i];
		//console.log(inputString);
		inputString = "\\b" + inputString.replace(" ", "\\b \\b") + "\\b";
		if(tweet.toLowerCase().match(inputString.toLowerCase())==null){
			//console.log("No such word combination found.");
			//return null;
		}
		else{
			//console.log(option[i]);
			return option[i];
			break;
		}
	}
};

function getNameToken(tweet,option){

	tokenizer = new natural.WordTokenizer(); //new tokeniser
	var tweetTokenised = tokenizer.tokenize(tweet); //tokenise the tweet and store it in tweetTokenised
	//console.log(tweetTokenised); //testing purposes
	var distances = [];

	var i , j;
	//loop through tokenised tweet
	for(i=0;i<tweetTokenised.length;i++){
		//console.log(tweetTokenised[i] + "--------------------------");
		var temp = [];
		//compare token with list of artists performing on option
		for(j=0;j<option.length;j++){
			//remove whitespace from the tweet tokens
			//console.log(tweetTokenised[i]+ "--->"+option[j]); //testing purposes
			var score = natural.LevenshteinDistance(tweetTokenised[i].replace(/\s+/g, '').toLowerCase(),option[j].replace(/\s+/g, '').toLowerCase());
			//store score for each token vs artists in a temp dictionary 
			temp.push({
				key:   option[j],
				value: score
			});
		}
		//sort array from lowest to biggest
		temp.sort(function(a, b) {
			return parseFloat(a.value) - parseFloat(b.value);
		});


		//console.log(temp);
		//get the first object (the smallest in this instance as its been sorted)
		lowest = temp.shift();
		//console.log(lowest);
		if(lowest.value < 4){
			distances.push(lowest);
		}
	}
	//console.log("printing distances");
	//console.log(distances);
	//if no match found return null
	if(distances[0] == null){
		return null;
	}
	else{ 
		return distances[0].key; //get artist name with the lowest score
	}
	
}

function getTime(tweet){
	var playingWords = ["playing now" , "about to go on" , "on stage now" , "ready" , "waiting"];
	for(i=0;i<playingWords.length;i++){
		//check for if the band is on stage at the time of the tweet.
		var current = playingWords[i];
		//console.log(current);
		current = "\\b" + current.replace(" ", "\\b \\b") + "\\b";
		//console.log(current);
		if(tweet.toLowerCase().match(current.toLowerCase())!=null){ //if there is a match
			//place holder
			//time = (tweets[i]["time"]);
			//console.log("match found");
			return 0;
			break;
		}
		else{
			//use regex to get time 
			var re = /(?:[0][0-9]|[1][012])(?::[0-5][0-9])?(?:am|pm)|(?:[0-1][0-9]|2[0-3]):(?:[0-5][0-9])/g;
			var arr = re.exec(tweet);
			if(arr!= null){
				return arr[0];
			}
		}

	}
	return null; //if no match found return null
	
}

function getTweets(callback){
	var connection = mysql.createConnection({
	host     : 'localhost',
	user     : 'root',
	password : '1',
	database : 'glasto2015'
	});

	var tweets = []
	connection.query('SELECT * FROM `tweets`', function (error, results, fields) {
		for (var i = 0; i < results.length; i++) {
			//console.log(results[i].tweet);
			tweets.push({
				tweet:results[i].tweet,
				date:results[i].date,
				time:results[i].time 
			});

		};
		//console.log(tweets);
		callback(tweets);
		
	});
	
	connection.end(function(err) {
		  // The connection is terminated gracefully
		  // Ensures all previously enqueued queries are still
		  // before sending a COM_QUIT packet to the MySQL server.
		  console.log("connection closed")
	});    
}

function addToNode(sentenceToAdd){
	node.add_ce(sentenceToAdd);

}

function checkNode(){

}


function run(){
CL.run(function* () {
    var tweets = yield getTweets(CL.done());
    // do stuff with tweets
    var i;
	for(i=0;i<tweets.length;i++){
    	console.log(tweets[i]["tweet"]);
    	var text = (tweets[i]["tweet"]);
    	var stage = getNameExact(text,stages); //call function to get stage name
    	var band = getNameExact(text,perfomers); //call function to get exact name 
    	if(band == null){
			band = getNameToken(text,perfomers); //if not exact match found use tokenised method
		}
		else{
			continue; //if a band name is not found move on to the next tweet
		}
    	var time = getTime(text);
    	if(time == 0){
    		time = (tweets[i]["time"]);
    	}
    	console.log(stage);
    	console.log(band);
    	console.log(time);
    	var sentenceToAdd  = "there is a band named " + band + " that plays at the time "  + time  + " and that has the stage " + stage + " as venue."
    	console.log(sentenceToAdd);
    	//addToNode(sentenceToAdd);
    }


});
}

/*async.series([
    getTweets(function(tweets){
    	var i;
    	for(i=0;i<tweets.length;i++){
	    	console.log(tweets[i]["tweet"]);
	    	var text = (tweets[i]["tweet"]);
	    	var stage = getNameExact(text,stages); //call function to get stage name
	    	var band = getNameExact(text,perfomers); //call function to get exact name 
	    	if(band == null){
				band = getNameToken(text,perfomers); //if not exact match found use tokenised method
			}
			else{
				continue; //if a band name is not found move on to the next tweet
			}
	    	var time = getTime(text);
	    	if(time == 0){
	    		time = (tweets[i]["time"]);
	    	}
	    	console.log(stage);
	    	console.log(band);
	    	console.log(time);
	    	var sentenceToAdd  = "there is a band named " + band + " that plays at the time "  + time  + " and that has the stage " + stage + " as venue."
	    	console.log(sentenceToAdd);
	    	addToNode(sentenceToAdd);
	    }
	})
])*/
/*var out = addToNode("test");
console.log(out);
return 0;

getTweets(function(tweets) {
    var i;
    for(i=0;i<tweets.length;i++){
    	console.log(tweets[i]["tweet"]);
    	var text = (tweets[i]["tweet"]);
    	var stage = getNameExact(text,stages); //call function to get stage name
    	var band = getNameExact(text,perfomers); //call function to get exact name 
    	if(band == null){
			band = getNameToken(text,perfomers); //if not exact match found use tokenised method
		}
		else{
			continue; //if a band name is not found move on to the next tweet
		}
    	var time = getTime(text);
    	if(time == 0){
    		time = (tweets[i]["time"]);
    	}
    	console.log(stage);
    	console.log(band);
    	console.log(time);
    	var sentenceToAdd  = "there is a band named " + band + " that plays at the time "  + time  + " and that has the stage " + stage + " as venue."
    	console.log(sentenceToAdd);
    	//addToNode(sentenceToAdd);
    	setTimeout(function(){
    		//do what you need here
    		var output = addToNode(sentenceToAdd);
    		console.log("------------added to NODE-----------------");
    		//for (var z in output) console.log(z + " ");
    		//for (i = 0; i < output.length; i++) console.log(output[i]);
    		console.log(output);
		}, 2000);


    	
    };  
});*/

//run();
var text = "Massive crowd for the Charlatans opening the Other Stage at 11am #glastonbury"
var stage = getNameExact(text,stages);
console.log(stage);
var band = getNameExact(text,perfomers);
console.log(band);
var time = getTime(text);
console.log(time);
//there is a band named 'Foo Fighters' that plays at the time '10:30pm' and that has the stage 'other stage' as venue and has 'http://www.mtv.com/crop-images/2013/09/11/Foo%20Fighters%20officail.jpg' as image.
var sentenceToAdd  = "there is a band named '" + band + "' that plays at the time '"  + time  + "' and that has the stage '" + stage + "' as venue."
//sentenceToAdd = "there is a band named 'Foo Fighters' that plays at the time '10:30pm' and that has the stage 'other stage' as venue and has 'http://www.mtv.com/crop-images/2013/09/11/Foo%20Fighters%20officail.jpg' as image."
console.log(sentenceToAdd);
//node.add_sentence(sentenceToAdd);
//node.add_sentence(sentenceToAdd);
//console.log(node.instances.foo_fighters);
//console.log(node.ask_question("who are the Charlatans?"));