//test of the getNameExact and getNameToken
var natural = require('natural');

var perfomers = ["Florence and the Machine",
"The Libertines",
"Motorhead",
"Mary J Blige",
"Jamie xx",
"The Charlatans"];


function getNameExact(tweet,option){

  for(var i = 0; i<option.length;i++){
    var inputString = option[i];
    //console.log(inputString);
    inputString = "\\b" + inputString.replace(" ", "\\b \\b") + "\\b";
    if(tweet.toLowerCase().match(inputString.toLowerCase())==null){
      //console.log("No such word combination found.");
      //return null;
    }
    else{
      //console.log(option[i]);
      return option[i];
      break;
    }
  }
};


function getNameToken(tweet,option){

  tokenizer = new natural.WordTokenizer(); //new tokeniser
  var tweetTokenised = tokenizer.tokenize(tweet); //tokenise the tweet and store it in tweetTokenised
  //console.log(tweetTokenised); //testing purposes
  var distances = [];

  var i , j;
  //loop through tokenised tweet
  for(i=0;i<tweetTokenised.length;i++){
    //console.log(tweetTokenised[i] + "--------------------------");
    var temp = [];
    //compare token with list of artists performing on option
    for(j=0;j<option.length;j++){
      //remove whitespace from the tweet tokens
      //console.log(tweetTokenised[i]+ "--->"+option[j]); //testing purposes
      var score = natural.LevenshteinDistance(tweetTokenised[i].replace(/\s+/g, '').toLowerCase(),option[j].replace(/\s+/g, '').toLowerCase());
      //store score for each token vs artists in a temp dictionary 
      temp.push({
        key:   option[j],
        value: score
      });
    }
    //sort array from lowest to biggest
    temp.sort(function(a, b) {
      return parseFloat(a.value) - parseFloat(b.value);
    });


    //console.log(temp);
    //get the first object (the smallest in this instance as its been sorted)
    lowest = temp.shift();
    //console.log(lowest);
    if(lowest.value < 4){
      distances.push(lowest);
    }
  }
  //console.log("printing distances");
  //console.log(distances);
  //if no match found return null
  if(distances[0] == null){
    return null;
  }
  else{ 
    return distances[0].key; //get artist name with the lowest score
  }
  
}

var text = "Massive crowd for the Charlatans opening the Other Stage at 11am #glastonbury";
var bandName = getNameExact(text,perfomers);
var bandNameToken = getNameToken(text,perfomers);
console.log("using getNameExact --> " + bandName);
console.log("using getNameToken --> " + bandNameToken);